
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] rmp440Install] >= 0 } {
    interp expose {} rmp440Install
}

proc ::rmp440Install { name } {
    foreach rqst { "Init" "SetCmdParam" "SetKinematicsParam" "GetDynamicsParam" "SetVarParam" "Stop" "JoystickOn" "Track" "SetPom" "SetPos" "Gyro" "GetGyro" "SetOdometryMethod" "Log" "StopLog" "LogInternalData" "StopInternalDataLog" "Goto" "MEPosmePosPosterRead" "OdoRobotPosterRead" "OdoVarPosterRead" "OdoRobot3dPosterRead" "RefrefPosterRead" "StatusstatusPosterRead" "StatusGenericstatusgenPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} rmp440$rqst $name
    }
}

interp hide {} rmp440Install




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440Init] >= 0 } {
    interp expose {} rmp440Init
}
if { [lsearch [interp hidden] rmp440InitFormatOutput] >= 0 } {
    interp expose {} rmp440InitFormatOutput
}

proc ::rmp440Init { name args } {
    set format {}
    lappend format [list string "device.name" "" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Connect to USB bus" \
	"GEN_STRING32\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::rmp440InitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440Init
interp hide {} rmp440InitFormatOutput





# SetCmdParam ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440SetCmdParam] >= 0 } {
    interp expose {} rmp440SetCmdParam
}
if { [lsearch [interp hidden] rmp440SetCmdParamFormatOutput] >= 0 } {
    interp expose {} rmp440SetCmdParamFormatOutput
}

proc ::rmp440SetCmdParam { name args } {
    set format {}
    lappend format [list double "cmd.distPoint" 0.0 ]
    lappend format [list double "cmd.KpLongit" 0.0 ]
    lappend format [list double "cmd.KiLongit" 0.0 ]
    lappend format [list double "cmd.KpTransv" 0.0 ]
    lappend format [list double "cmd.KiTransv" 0.0 ]
    lappend format [list double "cmd.KpAng" 0.0 ]
    lappend format [list double "cmd.KiAng" 0.0 ]
    lappend format [list double "cmd.longitErrorMax" 0.0 ]
    lappend format [list double "cmd.transvErrorMax" 0.0 ]
    lappend format [list double "cmd.longitMaxErrSum" 0.0 ]
    lappend format [list double "cmd.transvMaxErrSum" 0.0 ]
    lappend format [list double "cmd.angErrorMax" 0.0 ]
    lappend format [list double "cmd.angMaxErrSum" 0.0 ]
    lappend format [list double "cmd.longitMaxGap" 0.0 ]
    lappend format [list double "cmd.transvMaxGap" 0.0 ]
    lappend format [list double "cmd.angMaxGap" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetCmdParam" \
	"Set command parameters" \
	"GENPOS_CART_CMD_PARAM\n| double distPoint\n| double KpLongit\n| double KiLongit\n| double KpTransv\n| double KiTransv\n| double KpAng\n| double KiAng\n| double longitErrorMax\n| double transvErrorMax\n| double longitMaxErrSum\n| double transvMaxErrSum\n| double angErrorMax\n| double angMaxErrSum\n| double longitMaxGap\n| double transvMaxGap\n| double angMaxGap\n" \
	16 \
	$format \
	$args ]
}


proc ::rmp440SetCmdParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440SetCmdParam
interp hide {} rmp440SetCmdParamFormatOutput





# SetKinematicsParam ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440SetKinematicsParam] >= 0 } {
    interp expose {} rmp440SetKinematicsParam
}
if { [lsearch [interp hidden] rmp440SetKinematicsParamFormatOutput] >= 0 } {
    interp expose {} rmp440SetKinematicsParamFormatOutput
}

proc ::rmp440SetKinematicsParam { name args } {
    set format {}
    lappend format [list double "kinematics.leftWheelRadius" 0.0 ]
    lappend format [list double "kinematics.rightWheelRadius" 0.0 ]
    lappend format [list double "kinematics.axisWidth" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetKinematicsParam" \
	"Set Kinematic parameters" \
	"RMP440_KINEMATICS_STR\n| double leftWheelRadius\n| double rightWheelRadius\n| double axisWidth\n" \
	3 \
	$format \
	$args ]
}


proc ::rmp440SetKinematicsParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440SetKinematicsParam
interp hide {} rmp440SetKinematicsParamFormatOutput





# GetDynamicsParam ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440GetDynamicsParam] >= 0 } {
    interp expose {} rmp440GetDynamicsParam
}
if { [lsearch [interp hidden] rmp440GetDynamicsParamFormatOutput] >= 0 } {
    interp expose {} rmp440GetDynamicsParamFormatOutput
}

proc ::rmp440GetDynamicsParam { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetDynamicsParam" \
	"Get Dynamic parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp440GetDynamicsParamFormatOutput { list } {
    set format { {} status { } { dynamics { } vMax { } wMax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440GetDynamicsParam
interp hide {} rmp440GetDynamicsParamFormatOutput





# SetVarParam ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440SetVarParam] >= 0 } {
    interp expose {} rmp440SetVarParam
}
if { [lsearch [interp hidden] rmp440SetVarParamFormatOutput] >= 0 } {
    interp expose {} rmp440SetVarParamFormatOutput
}

proc ::rmp440SetVarParam { name args } {
    set format {}
    lappend format [list double "varParams.coeffLin" 0.0 ]
    lappend format [list double "varParams.coeffAng" 0.0 ]
    lappend format [list double "varParams.coeffLinAng" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetVarParam" \
	"Set Parameters of the uncertainty evaluation" \
	"RMP440_VAR_PARAMS\n| double coeffLin\n| double coeffAng\n| double coeffLinAng\n" \
	3 \
	$format \
	$args ]
}


proc ::rmp440SetVarParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440SetVarParam
interp hide {} rmp440SetVarParamFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440Stop] >= 0 } {
    interp expose {} rmp440Stop
}
if { [lsearch [interp hidden] rmp440StopFormatOutput] >= 0 } {
    interp expose {} rmp440StopFormatOutput
}

proc ::rmp440Stop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"Stop any on-going motion" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp440StopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440Stop
interp hide {} rmp440StopFormatOutput





# JoystickOn ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440JoystickOn] >= 0 } {
    interp expose {} rmp440JoystickOn
}
if { [lsearch [interp hidden] rmp440JoystickOnFormatOutput] >= 0 } {
    interp expose {} rmp440JoystickOnFormatOutput
}

proc ::rmp440JoystickOn { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "JoystickOn" \
	"Activate joystick motion mode" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp440JoystickOnFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440JoystickOn
interp hide {} rmp440JoystickOnFormatOutput





# Track ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440Track] >= 0 } {
    interp expose {} rmp440Track
}
if { [lsearch [interp hidden] rmp440TrackFormatOutput] >= 0 } {
    interp expose {} rmp440TrackFormatOutput
}

proc ::rmp440Track { name args } {
    set format {}
    lappend format [list string "trackParams.posterName.name" "" ]
    lappend format [list { "GENPOS_TRACK_TRAILER" "GENPOS_TRACK_SPEED" "GENPOS_TRACK_CONFIG" "GENPOS_TRACK_POS" "GENPOS_NO_TRACKING" } "trackParams.mode" "" ]

    return [ ::cs::rqstSend "${name}" "Track" \
	"Start tracking a reference poster" \
	"RMP440_TRACK_PARAMS\n| GENPOS_POSTER_NAME\n| | char name\[32\]\n| GENPOS_TRACK_MODE mode\n" \
	2 \
	$format \
	$args ]
}


proc ::rmp440TrackFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440Track
interp hide {} rmp440TrackFormatOutput





# SetPom ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440SetPom] >= 0 } {
    interp expose {} rmp440SetPom
}
if { [lsearch [interp hidden] rmp440SetPomFormatOutput] >= 0 } {
    interp expose {} rmp440SetPomFormatOutput
}

proc ::rmp440SetPom { name args } {
    set format {}
    lappend format [list string "mePosterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "SetPom" \
	"Define the name of the global POM poster" \
	"GENPOS_POSTER_NAME\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::rmp440SetPomFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440SetPom
interp hide {} rmp440SetPomFormatOutput





# SetPos ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440SetPos] >= 0 } {
    interp expose {} rmp440SetPos
}
if { [lsearch [interp hidden] rmp440SetPosFormatOutput] >= 0 } {
    interp expose {} rmp440SetPosFormatOutput
}

proc ::rmp440SetPos { name args } {
    set format {}
    lappend format [list double "setPosStr.x" 0.0 ]
    lappend format [list double "setPosStr.y" 0.0 ]
    lappend format [list double "setPosStr.z" 0.0 ]
    lappend format [list double "setPosStr.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetPos" \
	"** undocumented **" \
	"RMP440_CART_3DCONFIG\n| double x\n| double y\n| double z\n| double theta\n" \
	4 \
	$format \
	$args ]
}


proc ::rmp440SetPosFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440SetPos
interp hide {} rmp440SetPosFormatOutput





# Gyro ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440Gyro] >= 0 } {
    interp expose {} rmp440Gyro
}
if { [lsearch [interp hidden] rmp440GyroFormatOutput] >= 0 } {
    interp expose {} rmp440GyroFormatOutput
}

proc ::rmp440Gyro { name args } {
    set format {}
    lappend format [list { "RMP440_GYRO_ON" "RMP440_GYRO_ON_IF_MOTION" "RMP440_GYRO_OFF" } "params.mode" "" ]
    lappend format [list string "params.port" "" ]
    lappend format [list { "GYRO_KVH_DSP_3000" "GYRO_KVH_DSP_5000" "GYRO_KVH_ECORE_1000" "GYRO_UNKNOWN" } "params.type" "" ]
    lappend format [list double "params.latitude" 0.0 ]
    lappend format [list double "params.woffset" 0.0 ]

    return [ ::cs::rqstSend "${name}" "Gyro" \
	"Gyro configuration" \
	"RMP440_GYRO_PARAMS\n| RMP440_GYRO_MODE mode\n| char port\[32\]\n| GYRO_TYPE type\n| double latitude\n| double woffset\n" \
	5 \
	$format \
	$args ]
}


proc ::rmp440GyroFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440Gyro
interp hide {} rmp440GyroFormatOutput





# GetGyro ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440GetGyro] >= 0 } {
    interp expose {} rmp440GetGyro
}
if { [lsearch [interp hidden] rmp440GetGyroFormatOutput] >= 0 } {
    interp expose {} rmp440GetGyroFormatOutput
}

proc ::rmp440GetGyro { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetGyro" \
	"Returns gyro parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp440GetGyroFormatOutput { list } {
    set format { {} status { } { params { } mode { } port { } type { } latitude { } woffset } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440GetGyro
interp hide {} rmp440GetGyroFormatOutput





# SetOdometryMethod ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440SetOdometryMethod] >= 0 } {
    interp expose {} rmp440SetOdometryMethod
}
if { [lsearch [interp hidden] rmp440SetOdometryMethodFormatOutput] >= 0 } {
    interp expose {} rmp440SetOdometryMethodFormatOutput
}

proc ::rmp440SetOdometryMethod { name args } {
    set format {}
    lappend format [list { "RMP440_ODO_3D" "RMP440_ODO_2D" } "Odometry Method" "RMP440_ODO_2D" ]
    lappend format [list int "unused" 0 ]
    lappend format [list string "Attitude Poster Name" "imuAttitudeEstimation" ]

    return [ ::cs::rqstSend "${name}" "SetOdometryMethod" \
	"Odometry Configuration" \
	"RMP440_ODOMETRY_METHOD\n| RMP440_ODOMETRY_MODE mode\n| int unused\n| char attitudePosterName\[64\]\n" \
	3 \
	$format \
	$args ]
}


proc ::rmp440SetOdometryMethodFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440SetOdometryMethod
interp hide {} rmp440SetOdometryMethodFormatOutput





# Log ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440Log] >= 0 } {
    interp expose {} rmp440Log
}
if { [lsearch [interp hidden] rmp440LogFormatOutput] >= 0 } {
    interp expose {} rmp440LogFormatOutput
}

proc ::rmp440Log { name args } {
    set format {}
    lappend format [list string "fileName.name" "" ]

    return [ ::cs::rqstSend "${name}" "Log" \
	"Log robot configuration and date" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::rmp440LogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440Log
interp hide {} rmp440LogFormatOutput





# StopLog ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440StopLog] >= 0 } {
    interp expose {} rmp440StopLog
}
if { [lsearch [interp hidden] rmp440StopLogFormatOutput] >= 0 } {
    interp expose {} rmp440StopLogFormatOutput
}

proc ::rmp440StopLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopLog" \
	"Stop activity Log" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp440StopLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440StopLog
interp hide {} rmp440StopLogFormatOutput





# LogInternalData ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440LogInternalData] >= 0 } {
    interp expose {} rmp440LogInternalData
}
if { [lsearch [interp hidden] rmp440LogInternalDataFormatOutput] >= 0 } {
    interp expose {} rmp440LogInternalDataFormatOutput
}

proc ::rmp440LogInternalData { name args } {
    set format {}
    lappend format [list string "fileName.name" "" ]

    return [ ::cs::rqstSend "${name}" "LogInternalData" \
	"Log all the raw data provided by robot" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::rmp440LogInternalDataFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440LogInternalData
interp hide {} rmp440LogInternalDataFormatOutput





# StopInternalDataLog ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440StopInternalDataLog] >= 0 } {
    interp expose {} rmp440StopInternalDataLog
}
if { [lsearch [interp hidden] rmp440StopInternalDataLogFormatOutput] >= 0 } {
    interp expose {} rmp440StopInternalDataLogFormatOutput
}

proc ::rmp440StopInternalDataLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopInternalDataLog" \
	"Stop activity LogInternalLog" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp440StopInternalDataLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440StopInternalDataLog
interp hide {} rmp440StopInternalDataLogFormatOutput





# Goto ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440Goto] >= 0 } {
    interp expose {} rmp440Goto
}
if { [lsearch [interp hidden] rmp440GotoFormatOutput] >= 0 } {
    interp expose {} rmp440GotoFormatOutput
}

proc ::rmp440Goto { name args } {
    set format {}
    lappend format [list int "ref.numRef" 0 ]
    lappend format [list int "ref.tickPeriod" 0 ]
    lappend format [list { "GENPOS_POS_AND_SPEED_DATA" "GENPOS_SPEED_DATA" "GENPOS_POS_DATA" } "ref.dataType" "" ]
    lappend format [list { "GENPOS_BACKWARD_MOTION" "GENPOS_FORWARD_MOTION" } "ref.backFlag" "" ]
    lappend format [list double "ref.x" 0.0 ]
    lappend format [list double "ref.y" 0.0 ]
    lappend format [list double "ref.theta" 0.0 ]
    lappend format [list double "ref.v" 0.0 ]
    lappend format [list double "ref.vt" 0.0 ]
    lappend format [list double "ref.w" 0.0 ]
    lappend format [list double "ref.vmax" 0.0 ]
    lappend format [list double "ref.wmax" 0.0 ]
    lappend format [list double "ref.linAccelMax" 0.0 ]
    lappend format [list double "ref.angAccelMax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "Goto" \
	"Set a reference data" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	14 \
	$format \
	$args ]
}


proc ::rmp440GotoFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440Goto
interp hide {} rmp440GotoFormatOutput





# MEPosmePos ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440MEPosmePosPosterRead] >= 0 } {
    interp expose {} rmp440MEPosmePosPosterRead
}
if { [lsearch [interp hidden] rmp440MEPosmePosPosterFormatOutput] >= 0 } {
    interp expose {} rmp440MEPosmePosPosterFormatOutput
}

proc ::rmp440MEPosmePosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MEPosmePos" \
	"POM_ME_POS\n| POM_ME_CLASS kind\n| int unused\n| double confidence\n| int date1\n| int date2\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n" \
	$args ]
}


proc ::rmp440MEPosmePosPosterFormatOutput { list } {
    set format { {} status { } { mePos { } kind { } unused { } confidence { } date1 { } date2 { } { main { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440MEPosmePosPosterRead
interp hide {} rmp440MEPosmePosPosterFormatOutput





# OdoRobot ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440OdoRobotPosterRead] >= 0 } {
    interp expose {} rmp440OdoRobotPosterRead
}
if { [lsearch [interp hidden] rmp440OdoRobotPosterFormatOutput] >= 0 } {
    interp expose {} rmp440OdoRobotPosterFormatOutput
}

proc ::rmp440OdoRobotPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "OdoRobot" \
	"GENPOS_CART_STATE\n| double xRef\n| double yRef\n| double xRob\n| double yRob\n| double theta\n| double v\n| double vt\n| double w\n" \
	$args ]
}


proc ::rmp440OdoRobotPosterFormatOutput { list } {
    set format { {} status { } { Robot { } xRef { } yRef { } xRob { } yRob { } theta { } v { } vt { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440OdoRobotPosterRead
interp hide {} rmp440OdoRobotPosterFormatOutput





# OdoVar ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440OdoVarPosterRead] >= 0 } {
    interp expose {} rmp440OdoVarPosterRead
}
if { [lsearch [interp hidden] rmp440OdoVarPosterFormatOutput] >= 0 } {
    interp expose {} rmp440OdoVarPosterFormatOutput
}

proc ::rmp440OdoVarPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "OdoVar" \
	"GENPOS_CART_CONFIG_VAR\n| double var\[6\]\n" \
	$args ]
}


proc ::rmp440OdoVarPosterFormatOutput { list } {
    set format { {} status { } { Var { 6 } var } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440OdoVarPosterRead
interp hide {} rmp440OdoVarPosterFormatOutput





# OdoRobot3d ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440OdoRobot3dPosterRead] >= 0 } {
    interp expose {} rmp440OdoRobot3dPosterRead
}
if { [lsearch [interp hidden] rmp440OdoRobot3dPosterFormatOutput] >= 0 } {
    interp expose {} rmp440OdoRobot3dPosterFormatOutput
}

proc ::rmp440OdoRobot3dPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "OdoRobot3d" \
	"RMP440_CART_3DSTATE\n| double xRef\n| double yRef\n| double zRef\n| double xRob\n| double yRob\n| double zRob\n| double theta\n| double pitch\n| double roll\n| double v\n| double vt\n| double w\n" \
	$args ]
}


proc ::rmp440OdoRobot3dPosterFormatOutput { list } {
    set format { {} status { } { Robot3d { } xRef { } yRef { } zRef { } xRob { } yRob { } zRob { } theta { } pitch { } roll { } v { } vt { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440OdoRobot3dPosterRead
interp hide {} rmp440OdoRobot3dPosterFormatOutput





# Refref ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440RefrefPosterRead] >= 0 } {
    interp expose {} rmp440RefrefPosterRead
}
if { [lsearch [interp hidden] rmp440RefrefPosterFormatOutput] >= 0 } {
    interp expose {} rmp440RefrefPosterFormatOutput
}

proc ::rmp440RefrefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Refref" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::rmp440RefrefPosterFormatOutput { list } {
    set format { {} status { } { ref { } numRef { } tickPeriod { } dataType { } backFlag { } x { } y { } theta { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440RefrefPosterRead
interp hide {} rmp440RefrefPosterFormatOutput





# Statusstatus ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440StatusstatusPosterRead] >= 0 } {
    interp expose {} rmp440StatusstatusPosterRead
}
if { [lsearch [interp hidden] rmp440StatusstatusPosterFormatOutput] >= 0 } {
    interp expose {} rmp440StatusstatusPosterFormatOutput
}

proc ::rmp440StatusstatusPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Statusstatus" \
	"RMP440_STATUS_STR\n| RMP440_MODE rs_mode\n| RMP440_FEEDBACK\n| | unsigned int fault_status\[4\]\n| | unsigned int mcu_fault_status\[4\]\n| | float frame_count\n| | unsigned int operational_state\n| | unsigned int dynamic_response\n| | float min_propulsion_batt_soc\n| | float aux_batt_soc\n| | float inertial_x_acc\n| | float inertial_y_acc\n| | float inertial_x_rate\n| | float inertial_y_rate\n| | float inertial_z_rate\n| | float pse_pitch\n| | float pse_pitch_rate\n| | float pse_roll\n| | float pse_roll_rate\n| | float pse_yaw_rate\n| | unsigned int pse_data_is_valid\n| | float yaw_rate_limit\n| | float vel_limit\n| | float linear_accel\n| | float linear_vel\n| | float differential_wheel_vel\n| | float right_front_vel\n| | float left_front_vel\n| | float right_rear_vel\n| | float left_rear_vel\n| | float right_front_pos\n| | float left_front_pos\n| | float right_rear_pos\n| | float left_rear_pos\n| | float linear_pos\n| | float right_front_current\n| | float left_front_current\n| | float right_rear_current\n| | float left_rear_current\n| | float max_motor_current\n| | float right_front_current_limit\n| | float left_front_current_limit\n| | float right_rear_current_limit\n| | float left_rear_current_limit\n| | float min_motor_current_limit\n| | float front_base_batt_1_soc\n| | float front_base_batt_2_soc\n| | float rear_base_batt_1_soc\n| | float rear_base_batt_2_soc\n| | float front_base_batt_1_temp\n| | float front_base_batt_2_temp\n| | float rear_base_batt_1_temp\n| | float rear_base_batt_2_temp\n| | float vel_target\n| | float yaw_rate_target\n| | float angle_target\n| | float aux_batt_voltage\n| | float aux_batt_current\n| | float aux_batt_temp\n| | unsigned int abb_system_status\n| | unsigned int abb_batt_status\n| | unsigned int aux_batt_faults\n| | float ccu_7p2_battery_voltage\n| | unsigned int sp_sw_build_id\n| | unsigned int uip_sw_build_id\n| | float mcu_inst_power\[4\]\n| | float mcu_total_energy\[4\]\n| | float fram_vel_limit\n| | float fram_accel_limit\n| | float fram_decel_limit\n| | float fram_dtz_decel_limit\n| | float fram_coastdown_decel\n| | float fram_yaw_rate_limit\n| | float fram_yaw_accel_limit\n| | float fram_tire_diameter\n| | float fram_wheel_base_length\n| | float fram_wheel_track_width\n| | float fram_transmission_ratio\n| | unsigned int fram_config_bitmap\n| | unsigned int fram_eth_ip_address\n| | unsigned short int fram_eth_port_number\n| | unsigned int fram_eth_subnet_mask\n| | unsigned int fram_eth_gateway\n| | unsigned int user_feedback_bitmap\[4\]\n" \
	$args ]
}


proc ::rmp440StatusstatusPosterFormatOutput { list } {
    set format { {} status { } { status { } rs_mode { } { rs_data { 4 } fault_status { 4 } mcu_fault_status { } frame_count { } operational_state { } dynamic_response { } min_propulsion_batt_soc { } aux_batt_soc { } inertial_x_acc { } inertial_y_acc { } inertial_x_rate { } inertial_y_rate { } inertial_z_rate { } pse_pitch { } pse_pitch_rate { } pse_roll { } pse_roll_rate { } pse_yaw_rate { } pse_data_is_valid { } yaw_rate_limit { } vel_limit { } linear_accel { } linear_vel { } differential_wheel_vel { } right_front_vel { } left_front_vel { } right_rear_vel { } left_rear_vel { } right_front_pos { } left_front_pos { } right_rear_pos { } left_rear_pos { } linear_pos { } right_front_current { } left_front_current { } right_rear_current { } left_rear_current { } max_motor_current { } right_front_current_limit { } left_front_current_limit { } right_rear_current_limit { } left_rear_current_limit { } min_motor_current_limit { } front_base_batt_1_soc { } front_base_batt_2_soc { } rear_base_batt_1_soc { } rear_base_batt_2_soc { } front_base_batt_1_temp { } front_base_batt_2_temp { } rear_base_batt_1_temp { } rear_base_batt_2_temp { } vel_target { } yaw_rate_target { } angle_target { } aux_batt_voltage { } aux_batt_current { } aux_batt_temp { } abb_system_status { } abb_batt_status { } aux_batt_faults { } ccu_7p2_battery_voltage { } sp_sw_build_id { } uip_sw_build_id { 4 } mcu_inst_power { 4 } mcu_total_energy { } fram_vel_limit { } fram_accel_limit { } fram_decel_limit { } fram_dtz_decel_limit { } fram_coastdown_decel { } fram_yaw_rate_limit { } fram_yaw_accel_limit { } fram_tire_diameter { } fram_wheel_base_length { } fram_wheel_track_width { } fram_transmission_ratio { } fram_config_bitmap { } fram_eth_ip_address { } fram_eth_port_number { } fram_eth_subnet_mask { } fram_eth_gateway { 4 } user_feedback_bitmap } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440StatusstatusPosterRead
interp hide {} rmp440StatusstatusPosterFormatOutput





# StatusGenericstatusgen ----------------------------------------------------------

if { [lsearch [interp hidden] rmp440StatusGenericstatusgenPosterRead] >= 0 } {
    interp expose {} rmp440StatusGenericstatusgenPosterRead
}
if { [lsearch [interp hidden] rmp440StatusGenericstatusgenPosterFormatOutput] >= 0 } {
    interp expose {} rmp440StatusGenericstatusgenPosterFormatOutput
}

proc ::rmp440StatusGenericstatusgenPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "StatusGenericstatusgen" \
	"RMP_STATUS_STR\n| double receive_date\n| RMP_MODEL rmp_model\n| RMP440_MODE rs_mode\n| double propulsion_battery_level\n| double aux_battery_level\n| double pitch\n| double roll\n| double yaw_rate\n| double v\n| double w\n| double v_target\n| double w_target\n| float right_front_vel\n| float left_front_vel\n| float right_rear_vel\n| float left_rear_vel\n| float right_front_pos\n| float left_front_pos\n| float right_rear_pos\n| float left_rear_pos\n| float right_front_torque\n| float left_front_torque\n| float right_rear_torque\n| float left_rear_torque\n" \
	$args ]
}


proc ::rmp440StatusGenericstatusgenPosterFormatOutput { list } {
    set format { {} status { } { statusgen { } receive_date { } rmp_model { } rs_mode { } propulsion_battery_level { } aux_battery_level { } pitch { } roll { } yaw_rate { } v { } w { } v_target { } w_target { } right_front_vel { } left_front_vel { } right_rear_vel { } left_rear_vel { } right_front_pos { } left_front_pos { } right_rear_pos { } left_rear_pos { } right_front_torque { } left_front_torque { } right_rear_torque { } left_rear_torque } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp440StatusGenericstatusgenPosterRead
interp hide {} rmp440StatusGenericstatusgenPosterFormatOutput


